--- old/usr/src/uts/common/inet/tcp_impl.h	2012-06-13 12:05:25.899974274 +0000
+++ new/usr/src/uts/common/inet/tcp_impl.h	2012-06-13 12:05:25.956051712 +0000
@@ -546,10 +546,6 @@
 extern void	tcp_eager_cleanup(tcp_t *, boolean_t);
 extern void	tcp_eager_kill(void *, mblk_t *, void *, ip_recv_attr_t *);
 extern void	tcp_eager_unlink(tcp_t *);
-extern int	tcp_getpeername(sock_lower_handle_t, struct sockaddr *,
-		    socklen_t *, cred_t *);
-extern int	tcp_getsockname(sock_lower_handle_t, struct sockaddr *,
-		    socklen_t *, cred_t *);
 extern void	tcp_init_values(tcp_t *, tcp_t *);
 extern void	tcp_ipsec_cleanup(tcp_t *);
 extern int	tcp_maxpsz_set(tcp_t *, boolean_t);
@@ -679,7 +675,6 @@
 /*
  * TCP option processing related functions in tcp_opt_data.c
  */
-extern int	tcp_opt_default(queue_t *, t_scalar_t, t_scalar_t, uchar_t *);
 extern int	tcp_opt_get(conn_t *, int, int, uchar_t *);
 extern int	tcp_opt_set(conn_t *, uint_t, int, int, uint_t, uchar_t *,
 		    uint_t *, uchar_t *, void *, cred_t *);
--- old/usr/src/uts/common/inet/tcp_stats.h	2012-06-13 12:05:30.453505748 +0000
+++ new/usr/src/uts/common/inet/tcp_stats.h	2012-06-13 12:05:30.522054049 +0000
@@ -48,7 +48,7 @@
  *
  * TCP_DBGSTAT(name) does atomic increment of a named stat counter. It is
  * supposed to be used for DEBUG purposes and may be used on a hot path.
- * These counters are only available in a debugged kerel.  They are grouped
+ * These counters are only available in a debugged kernel.  They are grouped
  * under the TCP_DEBUG_COUNTER C pre-processor condition.
  *
  * Both TCP_STAT and TCP_DBGSTAT counters are available using kstat
--- old/usr/src/uts/common/inet/tunables.c	2012-06-13 12:05:31.977060593 +0000
+++ new/usr/src/uts/common/inet/tunables.c	2012-06-13 12:05:32.030973882 +0000
@@ -34,6 +34,8 @@
 #include <inet/tcp_stack.h>
 #include <inet/tcp_impl.h>
 #include <inet/udp_impl.h>
+#include <inet/dccp/dccp_stack.h>
+#include <inet/dccp/dccp_impl.h>
 #include <inet/sctp/sctp_stack.h>
 #include <inet/sctp/sctp_impl.h>
 #include <inet/tunables.h>
@@ -205,6 +207,7 @@
 	ip_stack_t	*ipst;
 	tcp_stack_t	*tcps;
 	sctp_stack_t	*sctps;
+	dccp_stack_t	*dccps;
 	udp_stack_t	*us;
 	icmp_stack_t	*is;
 	uint_t		size;
@@ -236,6 +239,10 @@
 		sctps = (sctp_stack_t *)cbarg;
 		ptbl = sctps->sctps_propinfo_tbl;
 		break;
+	case MOD_PROTO_DCCP:
+		dccps = (dccp_stack_t *)cbarg;
+		ptbl = dccps->dccps_propinfo_tbl;
+		break;
 	default:
 		return (EINVAL);
 	}
--- old/usr/src/uts/common/inet/tunables.h	2012-06-13 12:05:33.547902739 +0000
+++ new/usr/src/uts/common/inet/tunables.h	2012-06-13 12:05:33.585884377 +0000
@@ -79,6 +79,7 @@
 #define	MOD_PROTO_TCP		0x08	/* property is applicable to TCP */
 #define	MOD_PROTO_UDP		0x10	/* property is applicable to UDP */
 #define	MOD_PROTO_SCTP		0x20	/* property is applicable to SCTP */
+#define	MOD_PROTO_DCCP		0x40	/* property is applicable to DCCP */
 
 /* property is applicable to both IPV[4|6] */
 #define	MOD_PROTO_IP		(MOD_PROTO_IPV4|MOD_PROTO_IPV6)
--- /dev/null	2012-06-13 12:05:35.000000000 +0000
+++ new/usr/src/uts/common/netinet/dccp.h	2012-06-13 12:05:35.293318468 +0000
@@ -0,0 +1,38 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2012 David Hoeppner.  All rights reserved.
+ */
+
+#ifndef	_NETINET_DCCP_H
+#define	_NETINET_DCCP_H
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+/*
+ * DCCP states
+ */
+#define	DCCPS_CLOSED	-5
+#define	DCCPS_BOUND	-4
+#define DCCPS_LISTEN	-3
+#define	DCCPS_REQUEST	-2
+#define	DCCPS_RESPOND	-1
+#define DCCPS_PARTOPEN	0
+
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif	/* _NETINET_DCCP_H */
--- old/usr/src/uts/common/netinet/in.h	2012-06-13 12:05:36.059167290 +0000
+++ new/usr/src/uts/common/netinet/in.h	2012-06-13 12:05:36.125202370 +0000
@@ -159,6 +159,7 @@
 #define	IPPROTO_PUP		12		/* pup */
 #define	IPPROTO_UDP		17		/* user datagram protocol */
 #define	IPPROTO_IDP		22		/* xns idp */
+#define	IPPROTO_DCCP		33		/* DCCP */
 #define	IPPROTO_IPV6		41		/* IPv6 encapsulated in IP */
 #define	IPPROTO_ROUTING		43		/* Routing header for IPv6 */
 #define	IPPROTO_FRAGMENT	44		/* Fragment header for IPv6 */
--- old/usr/src/uts/common/sys/netstack.h	2012-06-13 12:05:41.026491211 +0000
+++ new/usr/src/uts/common/sys/netstack.h	2012-06-13 12:05:41.094931490 +0000
@@ -81,7 +81,8 @@
 #define	NS_IPSECESP	16
 #define	NS_IPNET	17
 #define	NS_ILB		18
-#define	NS_MAX		(NS_ILB+1)
+#define	NS_DCCP		19
+#define	NS_MAX		(NS_DCCP+1)
 
 /*
  * State maintained for each module which tracks the state of
@@ -157,6 +158,7 @@
 			struct ipsecesp_stack	*nu_ipsecesp;
 			struct ipnet_stack	*nu_ipnet;
 			struct ilb_stack	*nu_ilb;
+			struct dccp_stack	*nu_dccp;
 		} nu_s;
 	} netstack_u;
 #define	netstack_modules	netstack_u.nu_modules
@@ -179,6 +181,7 @@
 #define	netstack_ipsecesp	netstack_u.nu_s.nu_ipsecesp
 #define	netstack_ipnet		netstack_u.nu_s.nu_ipnet
 #define	netstack_ilb		netstack_u.nu_s.nu_ilb
+#define	netstack_dccp		netstack_u.nu_s.nu_dccp
 
 	nm_state_t	netstack_m_state[NS_MAX]; /* module state */
 
--- old/usr/src/uts/intel/Makefile.intel.shared	2012-06-13 12:05:42.711908862 +0000
+++ new/usr/src/uts/intel/Makefile.intel.shared	2012-06-13 12:05:42.788753919 +0000
@@ -230,6 +230,7 @@
 DRV_KMODS	+= crypto
 DRV_KMODS	+= cryptoadm
 DRV_KMODS	+= dca
+DRV_KMODS	+= dccp
 DRV_KMODS	+= devinfo
 DRV_KMODS	+= dld
 DRV_KMODS	+= dlpistub
--- /dev/null	2012-06-13 12:05:44.000000000 +0000
+++ new/usr/src/uts/intel/dccp/Makefile	2012-06-13 12:05:44.209134242 +0000
@@ -0,0 +1,98 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+#
+# uts/intel/dccp/Makefile
+#
+# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
+# Use is subject to license terms.
+#
+#	This makefile drives the production of the dccp driver kernel module.
+#
+#	intel implementation architecture dependent
+#
+
+#
+#	Path to the base of the uts directory tree (usually /usr/src/uts).
+#
+UTSBASE	= ../..
+
+#
+#	Define the module and object file sets.
+#
+MODULE		= dccp
+OBJECTS		= $(DCCP_OBJS:%=$(OBJS_DIR)/%)
+LINTS		= $(DCCP_OBJS:%.o=$(LINTS_DIR)/%.ln)
+ROOTMODULE	= $(ROOT_DRV_DIR)/$(MODULE)
+ROOTLINK	= $(ROOT_STRMOD_DIR)/$(MODULE) $(ROOT_SOCK_DIR)/$(MODULE)
+CONF_SRCDIR	= $(UTSBASE)/common/inet/dccp
+
+#
+# Extra for $(MODULE).check target
+#
+# Need to remove ipddi.o since it has non-static defines for _init etc.
+IP_CHECK_OBJS	= $(IP_OBJS:ipddi.o=ip.o)
+EXTRA_CHECK_OBJS = $(IP_CHECK_OBJS:%=../ip/$(OBJS_DIR)/%)
+
+#
+#	Include common rules.
+#
+include $(UTSBASE)/intel/Makefile.intel
+
+#
+#	Define targets
+#
+ALL_TARGET	= $(BINARY) $(SRC_CONFILE)
+LINT_TARGET	= $(MODULE).lint
+INSTALL_TARGET	= $(BINARY) $(ROOTMODULE) $(ROOTLINK) $(ROOT_CONFFILE)
+
+#
+#	depends on ip and sockfs
+#
+LDFLAGS		+= -dy -Ndrv/ip -Nfs/sockfs
+
+#
+#	Default build targets.
+#
+.KEEP_STATE:
+
+def:		$(DEF_DEPS)
+
+all:		$(ALL_DEPS)
+
+clean:		$(CLEAN_DEPS)
+
+clobber:	$(CLOBBER_DEPS)
+
+lint:		$(LINT_DEPS)
+
+modlintlib:	$(MODLINTLIB_DEPS)
+
+clean.lint:	$(CLEAN_LINT_DEPS)
+
+install:	$(INSTALL_DEPS)
+
+$(ROOTLINK):	$(ROOT_STRMOD_DIR) $(ROOT_SOCK_DIR) $(ROOTMODULE)
+	-$(RM) $@; ln $(ROOTMODULE) $@
+
+#
+#	Include common targets.
+#
+include $(UTSBASE)/intel/Makefile.targ
--- /dev/null	2012-06-13 12:05:44.000000000 +0000
+++ new/usr/src/uts/intel/dccp6/Makefile	2012-06-13 12:05:44.905544203 +0000
@@ -0,0 +1,93 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License, Version 1.0 only
+# (the "License").  You may not use this file except in compliance
+# with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+#
+# Copyright 2004 Sun Microsystems, Inc.  All rights reserved.
+# Use is subject to license terms.
+#
+#	This makefile drives the production of the dccp6 driver kernel module.
+#
+#	intel implementation architecture dependent
+#
+
+#
+#	Path to the base of the uts directory tree (usually /usr/src/uts).
+#
+UTSBASE	= ../..
+
+#
+#	Define the module and object file sets.
+#
+MODULE		= dccp6
+OBJECTS		= $(TCP6_OBJS:%=$(OBJS_DIR)/%)
+LINTS		= $(TCP6_OBJS:%.o=$(LINTS_DIR)/%.ln)
+ROOTMODULE	= $(ROOT_DRV_DIR)/$(MODULE)
+CONF_SRCDIR	= $(UTSBASE)/common/inet/dccp
+
+#
+# Extra for $(MODULE).check target
+#
+# Need to remove ipddi.o since it has non-static defines for _init etc.
+IP_CHECK_OBJS	= $(IP_OBJS:ipddi.o=ip.o)
+EXTRA_CHECK_OBJS = $(IP_CHECK_OBJS:%=../ip/$(OBJS_DIR)/%)
+
+#
+#	Include common rules.
+#
+include $(UTSBASE)/intel/Makefile.intel
+
+#
+#	Define targets
+#
+ALL_TARGET	= $(BINARY) $(SRC_CONFFILE)
+LINT_TARGET	= $(MODULE).lint
+INSTALL_TARGET	= $(BINARY) $(ROOTMODULE) $(ROOT_CONFFILE)
+
+#
+#	depends on tcp ip and ip6
+#
+LDFLAGS		+= -dy -Ndrv/tcp -Ndrv/ip -Ndrv/ip6
+
+#
+#	Default build targets.
+#
+.KEEP_STATE:
+
+def:		$(DEF_DEPS)
+
+all:		$(ALL_DEPS)
+
+clean:		$(CLEAN_DEPS)
+
+clobber:	$(CLOBBER_DEPS)
+
+lint:		$(LINT_DEPS)
+
+modlintlib:	$(MODLINTLIB_DEPS)
+
+clean.lint:	$(CLEAN_LINT_DEPS)
+
+install:	$(INSTALL_DEPS)
+
+#
+#	Include common targets.
+#
+include $(UTSBASE)/intel/Makefile.targ
--- old/usr/src/uts/intel/ip/ip.global-objs.debug64	2012-06-13 12:05:45.644357295 +0000
+++ new/usr/src/uts/intel/ip/ip.global-objs.debug64	2012-06-13 12:05:45.703961061 +0000
@@ -48,6 +48,22 @@
 cl_sctp_listen
 cl_sctp_unlisten
 conn_drain_nthreads
+dccp_bind_fanout_size
+dccp_conn_cache
+dccp_max_optsize
+dccp_opt_arr
+dccp_opt_obj
+dccp_propinfo_count
+dccp_propinfo_tbl
+dccp_random_anon_port
+dccp_rinfo
+dccp_rinitv4
+dccp_rinitv6
+dccp_valid_levels_arr
+dccp_winfo
+dccp_winit
+dccpinfov4
+dccpinfov6
 dce_cache
 default_ip6_asp_table
 do_tcp_fusion
@@ -144,6 +160,7 @@
 ipcl_conn_hash_maxsize
 ipcl_conn_hash_memfactor
 ipcl_conn_hash_size
+ipcl_dccp_fanout_size
 ipcl_iptun_fanout_size
 ipcl_raw_fanout_size
 ipcl_udp_fanout_size
@@ -236,6 +253,7 @@
 sin6_null
 sin_null
 skip_sctp_cksum
+sock_dccp_downcalls
 sock_rawip_downcalls
 sock_rts_downcalls
 sock_tcp_downcalls
--- old/usr/src/uts/intel/ip/ip.global-objs.obj64	2012-06-13 12:05:47.263274118 +0000
+++ new/usr/src/uts/intel/ip/ip.global-objs.obj64	2012-06-13 12:05:47.327377570 +0000
@@ -48,6 +48,22 @@
 cl_sctp_listen
 cl_sctp_unlisten
 conn_drain_nthreads
+dccp_bind_fanout_size
+dccp_conn_cache
+dccp_max_optsize
+dccp_opt_arr
+dccp_opt_obj
+dccp_propinfo_count
+dccp_propinfo_tbl
+dccp_random_anon_port
+dccp_rinfo
+dccp_rinitv4
+dccp_rinitv6
+dccp_valid_levels_arr
+dccp_winfo
+dccp_winit
+dccpinfov4
+dccpinfov6
 dce_cache
 default_ip6_asp_table
 do_tcp_fusion
@@ -144,6 +160,7 @@
 ipcl_conn_hash_maxsize
 ipcl_conn_hash_memfactor
 ipcl_conn_hash_size
+ipcl_dccp_fanout_size
 ipcl_iptun_fanout_size
 ipcl_raw_fanout_size
 ipcl_udp_fanout_size
@@ -233,6 +250,7 @@
 sctpdebug
 sin6_null
 sin_null
+sock_dccp_downcalls
 sock_rawip_downcalls
 sock_rts_downcalls
 sock_tcp_downcalls
